#include <Encoder.h>
#define DT_PIN 2
#define CLK_PIN 3
#define BUTTON_PIN 4

Encoder encoder(DT_PIN, CLK_PIN);

int lastEncoderValue = 0;
int lastButtonState = LOW;

void setup() {
  Serial.begin(9600);
  pinMode(BUTTON_PIN, INPUT_PULLUP);
}

void loop() {
  int encoderValue = encoder.read() / 4;
  int buttonState = !digitalRead(BUTTON_PIN);

  if (encoderValue != lastEncoderValue) {
    Serial.println("Encoder: " + String(encoderValue));
  }
  lastEncoderValue = encoderValue;

  if (buttonState != lastButtonState && buttonState == HIGH) {
    encoder.write(0);
    delay(200);
  }
  lastButtonState = buttonState;
}

